#!/usr/bin/env fish
#
# Copyright (c) 2016 Daichi GOTO <daichi@ongs.co.jp>

## wa.fish
##      天気警報情報をメールで送信

# 作業用ディレクトリの作成と削除処理の設定
set tmpd /tmp/(command date +%Y%m%d_%H%M%S)_(echo %self); mkdir $tmpd
function on_exit --on-process %self
        rm -rf $tmpd
end

# 必要データ設定
set email <ここに報告したいメール@アドレスを指定>
set url http://weather.yahoo.co.jp/weather/jp/13/4410/13225.html
set url2 http://tokyo-ame.jwa.or.jp/

# 天気予報データ取得
set --export LANG ja_JP.UTF-8
curl --get $url ^ /dev/null                             > $tmpd/src

# 天気情報を抽出
set key http://i.yimg.jp/images/weather/general/forecast/pinpoint/size40/
grep $key $tmpd/src                                     |\
# 時刻データを付与
mawk 'BEGIN{i=0}{print i, $0;i=(i+3)%24}'               |\
# すでに経過した天気情報は削除
grep -v _g.gif                                          |\
sed 's/^\([0-9]*\) .*alt="\([^"]*\)".*$/\1:\2/'         > $tmpd/tenki

cat $tmpd/tenki

# 天気予報の中に雨の予報がない場合には処理終了
grep 雨 $tmpd/tenki > /dev/null; or exit

# 天気予報をメールで報告
set tenki (cat $tmpd/tenki | tr '\n' ' ')
echo $tenki\n\n$url\n$url2 | mail -s ALERT:\ $tenki $email